#include <TimerFreeTone.h> //control speaker
#include <Wire.h>
#include <LiquidCrystal_I2C.h> //control lcd with i2c

#define speaker PIN_PD6
#define bpro PIN_PC1
#define bC PIN_PB0
#define bD PIN_PB1
#define bE PIN_PB2
#define bF PIN_PB3
#define bG PIN_PB4
#define bA PIN_PB5
#define bB PIN_PC0




LiquidCrystal_I2C lcd(0x27, 16, 2);
int melodyFreq[] = { 262, 294, 330, 349, 392, 440, 493};
int duration[] = { 150, 150, 150, 150, 150, 150, 150};
int melodyStart[] = { 262, 196, 196, 220, 196, 0, 247, 262 };
int durationStart[] = { 250, 125, 125, 250, 250, 250, 250, 250 };
int melodyEnd[] = {523, 392, 330, 440, 493, 440, 415, 446, 415, 392};
int durationEnd[] = {125, 125, 250, 125, 125, 125, 125, 125, 125, 250};
char melody[] = {"CDEFGAB"};
String clearRow  = "                ";




void setup() {
  pinMode(bpro, INPUT_PULLUP);
  pinMode(bC, INPUT_PULLUP);
  pinMode(bD, INPUT_PULLUP);
  pinMode(bE, INPUT_PULLUP);
  pinMode(bF, INPUT_PULLUP);
  pinMode(bG, INPUT_PULLUP);
  pinMode(bA, INPUT_PULLUP);
  pinMode(bB, INPUT_PULLUP);
  lcd.begin();
// Turn on the blacklight and print a message.
  //lcd.backlight();  
}
#define proPressed() !digitalRead(bpro)
#define somePressed() !(digitalRead(bC) && digitalRead(bD) && digitalRead(bE) && digitalRead(bF) && digitalRead(bG) && digitalRead(bA) && digitalRead(bB) && digitalRead(bpro))
#define somePressed2() !(digitalRead(bC) && digitalRead(bD) && digitalRead(bE) && digitalRead(bF) && digitalRead(bG) && digitalRead(bA) && digitalRead(bB))
bool trainProcess = false;

void Start(){
  lcd.clear();
  lcd.setCursor(0, 0); 
  lcd.print("Ear Training");
  for(int i = 0; i<8; i++){
    TimerFreeTone(speaker, melodyStart[i], durationStart[i]); delay(50);
  }
  lcd.setCursor(1, 1);  
  lcd.print(" Press to start");
  while(!trainProcess){
    if(somePressed()) trainProcess = true;
  }
  delay(50);
  while(somePressed()){
    ;
  }
  delay(50);
  lcd.display();
}

void End(int lv){
  lcd.clear();
  lcd.print("Training end");
  lcd.setCursor(0,1);
  lcd.print("ear score: ");
  lcd.setCursor(12,1);
  lcd.print(lv-1);
  for(int i = 0; i<10; i++){
    TimerFreeTone(speaker, melodyEnd[i], durationEnd[i]); delay(50);
  }
  delay(2000);
}

void loop() {
  Start();
  
  lcd.clear();
  lcd.print("Training start!");
  for(int i = 0; i<8; i++){
    TimerFreeTone(speaker, melodyFreq[i], duration[i]); delay(50);
  } 
  delay(100);
  int level = 1;
  while(trainProcess){
    lcd.clear();
    lcd.print("Listen!!"); delay(500);
    char solve[16];
    int solveNum[16];
    for(int rnd =0; rnd<level && trainProcess; rnd++){
       int note = millis()%7;
       TimerFreeTone(speaker, melodyFreq[note], 500);
       solve[rnd] = melody[note];
       solveNum[rnd] = note;
       /*int tmstmp = millis();//
       while(millis()- tmstmp < 800){
        if(proPressed()){
          trainProcess = false;
          break;
        }
       }//*/
       if(proPressed()){
          trainProcess = false;
          break;
       }
       delay(400); //
    }
    if(!trainProcess){
      End(level);
      break;
    }
    lcd.clear();
    lcd.print("Your answer?");
    bool isCorrect = true; 
    bool late = false;
    delay(200);
    for(int rnd =0; rnd<level && trainProcess; rnd++){ //answer
       bool ans[] = {false, false, false, false, false, false, false};
       unsigned long timeStamp = millis();
       while(!(ans[0] || ans[1] || ans[2] || ans[3] || ans[4] || ans[5] || ans[6])){
        if(proPressed()){
          trainProcess = false;
          break;
        }
        if(millis()-timeStamp > 6000 - level*100){
          late = true;
          isCorrect = false ;//long
          break;
        }
        ans[0] = !digitalRead(bC);
        ans[1] = !digitalRead(bD);
        ans[2] = !digitalRead(bE);
        ans[3] = !digitalRead(bF);
        ans[4] = !digitalRead(bG);
        ans[5] = !digitalRead(bA);
        ans[6] = !digitalRead(bB); 
       }
       
       if(!trainProcess || late){
         break;
       }
       int sel;
       for(int a =0 ; a<7; a++){
        if(ans[a]) sel = a;
          
       }
       if(sel != solveNum[rnd])  isCorrect = false;
       lcd.setCursor(rnd, 1);
       lcd.write(melody[sel]);
       delay(50);
       while(!somePressed()){
        ;
       }
       delay(50);
       TimerFreeTone(speaker, melodyFreq[sel],300); 
       //delay(100);      
    }
    delay(200);
    if(!trainProcess || (level >= 16)){
        End(level);
        
        break;
    }
    lcd.clear();
    if(isCorrect){
      level++; 
      lcd.print("Correct!!");
    }
    else{
      if(late) lcd.print("Time Up!!");
      else lcd.print("Wrong!!");
      delay(1200);
      lcd.clear();
      lcd.print("Solve is");  
      for(int i = 0; i<level; i++){
        lcd.setCursor(i,1);
        lcd.write(solve[i]);
        TimerFreeTone(speaker, melodyFreq[solveNum[i]],500);
        if(proPressed()){
          trainProcess = false;
          break;
        } 
        delay(400);
      }
      if(!trainProcess){
        End(level);
        break;
      }
      delay(200);
      lcd.setCursor(0,0);
      lcd.print("Continue? press!");
      while(!somePressed2()){
        if(proPressed()){
          trainProcess = false;
          End(level);
          break;
        }
      }
    }
    delay(800);
    
  }
  
}
